package com.ruoyi.web.base.controller;


import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.framework.web.service.TokenService;
import com.ruoyi.web.base.domain.ProcureSettlementGoods;
import com.ruoyi.web.base.service.IProcureSettlementGoodsService;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import java.util.Map;

import static com.ruoyi.common.core.domain.AjaxResult.success;
import static com.ruoyi.common.utils.SecurityUtils.getUsername;

/**
 * <p>
 * 采购结算单,物料单 前端控制器
 * </p>
 *
 * @author author
 * @since 2026-02-05
 */
@RestController
@RequestMapping("/procure-settlement-goods")
public class ProcureSettlementGoodsController {
    @Autowired
    private IProcureSettlementGoodsService procureSettlementGoodsService;
    @Autowired
    private TokenService tokenService;

    @ApiOperation("分摊管理添加")
    @PostMapping("/add")
    public AjaxResult add(@RequestBody ProcureSettlementGoods procureSettlementGoods, HttpServletRequest request) throws Exception {
        String loginOrgId = tokenService.getLoginOrgId(request);
        if (procureSettlementGoodsService.count(new QueryWrapper<ProcureSettlementGoods>().eq("org_id",loginOrgId).eq("settlement_no", procureSettlementGoods.getSettlementNo())) >0 ){
            throw new Exception("该编号已存在");
        }
        procureSettlementGoods.setOrgId(loginOrgId);
        procureSettlementGoods.setCreateBy(getUsername());

        return success(procureSettlementGoodsService.save(procureSettlementGoods));
    }

    @ApiOperation("分摊管理修改")
    @PostMapping("/edit")
    public AjaxResult edit(@RequestBody ProcureSettlementGoods procureSettlementGoods, HttpServletRequest request) throws Exception {
        String loginOrgId = tokenService.getLoginOrgId(request);
        if (procureSettlementGoodsService.count(new QueryWrapper<ProcureSettlementGoods>().ne("id",procureSettlementGoods.getId()).eq("org_id",loginOrgId).eq("settlement_no", procureSettlementGoods.getSettlementNo())) >0 ){
            throw new Exception("该编号已存在");
        }
        procureSettlementGoods.setUpdateBy(getUsername());
        return success(procureSettlementGoodsService.updateById(procureSettlementGoods));
    }

    @ApiOperation("分摊管理删除")
    @PostMapping("/delete")
    public AjaxResult delete(@RequestBody Map<String, String> paramsMap) {
        String ids = paramsMap.get("ids");
        for (String s : ids.split(",")) {
            procureSettlementGoodsService.removeById(s);
        }
        return success();
    }

    @ApiOperation("分摊管理列表")
    @PostMapping("/list")
    public AjaxResult listAll( HttpServletRequest request){

        return success(procureSettlementGoodsService.list(new QueryWrapper<ProcureSettlementGoods>().eq("org_id", tokenService.getLoginOrgId(request))));
    }

    @ApiOperation("分摊管理分页")
    @GetMapping("/page")
    public AjaxResult page(@RequestParam("pageNum") Integer pageNum, @RequestParam("pageSize") Integer pageSize
            , HttpServletRequest request) {
        return success(procureSettlementGoodsService.page(new Page<ProcureSettlementGoods>(pageNum,pageSize),new QueryWrapper<ProcureSettlementGoods>().eq("org_id", tokenService.getLoginOrgId(request))));
    }

    @ApiOperation("分摊管理详情")
    @PostMapping("/listById")
    public AjaxResult listById(@RequestBody Map<String, String> paramsMap){
        String id = paramsMap.get("id");
        return success(procureSettlementGoodsService.getById(id));
    }

}
